gitweb: use new Git::Repo API, and add optional caching
[git/gitweb-caching.git] / git-am.sh
blobaa602618e6caedbfdd2d54ad4bb8375356cc55f6
1 #!/bin/sh
3 # Copyright (c) 2005, 2006 Junio C Hamano
5 SUBDIRECTORY_OK=Yes
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git am [options] [<mbox>|<Maildir>...]
9 git am [options] (--resolved | --skip | --abort)
11 d,dotest= (removed -- do not use)
12 i,interactive run interactively
13 b,binary (historical option -- no-op)
14 3,3way allow fall back on 3way merging if needed
15 s,signoff add a Signed-off-by line to the commit message
16 u,utf8 recode into utf8 (default)
17 k,keep pass -k flag to git-mailinfo
18 whitespace= pass it through git-apply
19 C= pass it through git-apply
20 p= pass it through git-apply
21 resolvemsg= override error message when patch failure occurs
22 r,resolved to be used after a patch failure
23 skip skip the current patch
24 abort restore the original branch and abort the patching operation.
25 rebasing (internal use for git-rebase)"
27 . git-sh-setup
28 prefix=$(git rev-parse --show-prefix)
29 set_reflog_action am
30 require_work_tree
31 cd_to_toplevel
33 git var GIT_COMMITTER_IDENT >/dev/null ||
34 die "You need to set your committer info first"
36 stop_here () {
37 echo "$1" >"$dotest/next"
38 exit 1
41 stop_here_user_resolve () {
42 if [ -n "$resolvemsg" ]; then
43 printf '%s\n' "$resolvemsg"
44 stop_here $1
46 cmdline="git am"
47 if test '' != "$interactive"
48 then
49 cmdline="$cmdline -i"
51 if test '' != "$threeway"
52 then
53 cmdline="$cmdline -3"
55 echo "When you have resolved this problem run \"$cmdline --resolved\"."
56 echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."
57 echo "To restore the original branch and stop patching run \"$cmdline --abort\"."
59 stop_here $1
62 go_next () {
63 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
64 "$dotest/patch" "$dotest/info"
65 echo "$next" >"$dotest/next"
66 this=$next
69 cannot_fallback () {
70 echo "$1"
71 echo "Cannot fall back to three-way merge."
72 exit 1
75 fall_back_3way () {
76 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
78 rm -fr "$dotest"/patch-merge-*
79 mkdir "$dotest/patch-merge-tmp-dir"
81 # First see if the patch records the index info that we can use.
82 git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
83 "$dotest/patch" &&
84 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
85 git write-tree >"$dotest/patch-merge-base+" ||
86 cannot_fallback "Repository lacks necessary blobs to fall back on 3-way merge."
88 echo Using index info to reconstruct a base tree...
89 if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
90 git apply --cached <"$dotest/patch"
91 then
92 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
93 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
94 else
95 cannot_fallback "Did you hand edit your patch?
96 It does not apply to blobs recorded in its index."
99 test -f "$dotest/patch-merge-index" &&
100 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
101 orig_tree=$(cat "$dotest/patch-merge-base") &&
102 rm -fr "$dotest"/patch-merge-* || exit 1
104 echo Falling back to patching base and 3-way merge...
106 # This is not so wrong. Depending on which base we picked,
107 # orig_tree may be wildly different from ours, but his_tree
108 # has the same set of wildly different changes in parts the
109 # patch did not touch, so recursive ends up canceling them,
110 # saying that we reverted all those changes.
112 eval GITHEAD_$his_tree='"$FIRSTLINE"'
113 export GITHEAD_$his_tree
114 git-merge-recursive $orig_tree -- HEAD $his_tree || {
115 git rerere
116 echo Failed to merge in the changes.
117 exit 1
119 unset GITHEAD_$his_tree
122 prec=4
123 dotest="$GIT_DIR/rebase-apply"
124 sign= utf8=t keep= skip= interactive= resolved= rebasing= abort=
125 resolvemsg= resume=
126 git_apply_opt=
128 while test $# != 0
130 case "$1" in
131 -i|--interactive)
132 interactive=t ;;
133 -b|--binary)
134 : ;;
135 -3|--3way)
136 threeway=t ;;
137 -s|--signoff)
138 sign=t ;;
139 -u|--utf8)
140 utf8=t ;; # this is now default
141 --no-utf8)
142 utf8= ;;
143 -k|--keep)
144 keep=t ;;
145 -r|--resolved)
146 resolved=t ;;
147 --skip)
148 skip=t ;;
149 --abort)
150 abort=t ;;
151 --rebasing)
152 rebasing=t threeway=t keep=t ;;
153 -d|--dotest)
154 die "-d option is no longer supported. Do not use."
156 --resolvemsg)
157 shift; resolvemsg=$1 ;;
158 --whitespace)
159 git_apply_opt="$git_apply_opt $1=$2"; shift ;;
160 -C|-p)
161 git_apply_opt="$git_apply_opt $1$2"; shift ;;
163 shift; break ;;
165 usage ;;
166 esac
167 shift
168 done
170 # If the dotest directory exists, but we have finished applying all the
171 # patches in them, clear it out.
172 if test -d "$dotest" &&
173 last=$(cat "$dotest/last") &&
174 next=$(cat "$dotest/next") &&
175 test $# != 0 &&
176 test "$next" -gt "$last"
177 then
178 rm -fr "$dotest"
181 if test -d "$dotest"
182 then
183 case "$#,$skip$resolved$abort" in
184 0,*t*)
185 # Explicit resume command and we do not have file, so
186 # we are happy.
187 : ;;
189 # No file input but without resume parameters; catch
190 # user error to feed us a patch from standard input
191 # when there is already $dotest. This is somewhat
192 # unreliable -- stdin could be /dev/null for example
193 # and the caller did not intend to feed us a patch but
194 # wanted to continue unattended.
195 tty -s
198 false
200 esac ||
201 die "previous rebase directory $dotest still exists but mbox given."
202 resume=yes
204 case "$skip,$abort" in
206 git rerere clear
207 git read-tree --reset -u HEAD HEAD
208 orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
209 git reset HEAD
210 git update-ref ORIG_HEAD $orig_head
213 git rerere clear
214 git read-tree --reset -u HEAD ORIG_HEAD
215 git reset ORIG_HEAD
216 rm -fr "$dotest"
217 exit ;;
218 esac
219 else
220 # Make sure we are not given --skip, --resolved, nor --abort
221 test "$skip$resolved$abort" = "" ||
222 die "Resolve operation not in progress, we are not resuming."
224 # Start afresh.
225 mkdir -p "$dotest" || exit
227 if test -n "$prefix" && test $# != 0
228 then
229 first=t
230 for arg
232 test -n "$first" && {
233 set x
234 first=
236 case "$arg" in
238 set "$@" "$arg" ;;
240 set "$@" "$prefix$arg" ;;
241 esac
242 done
243 shift
245 git mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
246 rm -fr "$dotest"
247 exit 1
250 # -s, -u, -k and --whitespace flags are kept for the
251 # resuming session after a patch failure.
252 # -3 and -i can and must be given when resuming.
253 echo " $ws" >"$dotest/whitespace"
254 echo "$sign" >"$dotest/sign"
255 echo "$utf8" >"$dotest/utf8"
256 echo "$keep" >"$dotest/keep"
257 echo 1 >"$dotest/next"
258 if test -n "$rebasing"
259 then
260 : >"$dotest/rebasing"
261 else
262 : >"$dotest/applying"
263 git update-ref ORIG_HEAD HEAD
267 case "$resolved" in
269 files=$(git diff-index --cached --name-only HEAD --) || exit
270 if [ "$files" ]; then
271 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
272 exit 1
274 esac
276 if test "$(cat "$dotest/utf8")" = t
277 then
278 utf8=-u
279 else
280 utf8=-n
282 if test "$(cat "$dotest/keep")" = t
283 then
284 keep=-k
286 ws=`cat "$dotest/whitespace"`
287 if test "$(cat "$dotest/sign")" = t
288 then
289 SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
290 s/>.*/>/
291 s/^/Signed-off-by: /'
293 else
294 SIGNOFF=
297 last=`cat "$dotest/last"`
298 this=`cat "$dotest/next"`
299 if test "$skip" = t
300 then
301 this=`expr "$this" + 1`
302 resume=
305 if test "$this" -gt "$last"
306 then
307 echo Nothing to do.
308 rm -fr "$dotest"
309 exit
312 while test "$this" -le "$last"
314 msgnum=`printf "%0${prec}d" $this`
315 next=`expr "$this" + 1`
316 test -f "$dotest/$msgnum" || {
317 resume=
318 go_next
319 continue
322 # If we are not resuming, parse and extract the patch information
323 # into separate files:
324 # - info records the authorship and title
325 # - msg is the rest of commit log message
326 # - patch is the patch body.
328 # When we are resuming, these files are either already prepared
329 # by the user, or the user can tell us to do so by --resolved flag.
330 case "$resume" in
332 git mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
333 <"$dotest/$msgnum" >"$dotest/info" ||
334 stop_here $this
336 # skip pine's internal folder data
337 grep '^Author: Mail System Internal Data$' \
338 <"$dotest"/info >/dev/null &&
339 go_next && continue
341 test -s "$dotest/patch" || {
342 echo "Patch is empty. Was it split wrong?"
343 stop_here $this
345 if test -f "$dotest/rebasing" &&
346 commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
347 -e q "$dotest/$msgnum") &&
348 test "$(git cat-file -t "$commit")" = commit
349 then
350 git cat-file commit "$commit" |
351 sed -e '1,/^$/d' >"$dotest/msg-clean"
352 else
353 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
354 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
356 (printf '%s\n\n' "$SUBJECT"; cat "$dotest/msg") |
357 git stripspace > "$dotest/msg-clean"
360 esac
362 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
363 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
364 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
366 if test -z "$GIT_AUTHOR_EMAIL"
367 then
368 echo "Patch does not have a valid e-mail address."
369 stop_here $this
372 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
374 case "$resume" in
376 if test '' != "$SIGNOFF"
377 then
378 LAST_SIGNED_OFF_BY=`
379 sed -ne '/^Signed-off-by: /p' \
380 "$dotest/msg-clean" |
381 sed -ne '$p'
383 ADD_SIGNOFF=`
384 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
385 test '' = "$LAST_SIGNED_OFF_BY" && echo
386 echo "$SIGNOFF"
388 else
389 ADD_SIGNOFF=
392 if test -s "$dotest/msg-clean"
393 then
394 cat "$dotest/msg-clean"
396 if test '' != "$ADD_SIGNOFF"
397 then
398 echo "$ADD_SIGNOFF"
400 } >"$dotest/final-commit"
403 case "$resolved$interactive" in
405 # This is used only for interactive view option.
406 git diff-index -p --cached HEAD -- >"$dotest/patch"
408 esac
409 esac
411 resume=
412 if test "$interactive" = t
413 then
414 test -t 0 ||
415 die "cannot be interactive without stdin connected to a terminal."
416 action=again
417 while test "$action" = again
419 echo "Commit Body is:"
420 echo "--------------------------"
421 cat "$dotest/final-commit"
422 echo "--------------------------"
423 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
424 read reply
425 case "$reply" in
426 [yY]*) action=yes ;;
427 [aA]*) action=yes interactive= ;;
428 [nN]*) action=skip ;;
429 [eE]*) git_editor "$dotest/final-commit"
430 action=again ;;
431 [vV]*) action=again
432 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
433 *) action=again ;;
434 esac
435 done
436 else
437 action=yes
439 FIRSTLINE=$(sed 1q "$dotest/final-commit")
441 if test $action = skip
442 then
443 go_next
444 continue
447 if test -x "$GIT_DIR"/hooks/applypatch-msg
448 then
449 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
450 stop_here $this
453 printf 'Applying: %s\n' "$FIRSTLINE"
455 case "$resolved" in
457 git apply $git_apply_opt --index "$dotest/patch"
458 apply_status=$?
461 # Resolved means the user did all the hard work, and
462 # we do not have to do any patch application. Just
463 # trust what the user has in the index file and the
464 # working tree.
465 resolved=
466 git diff-index --quiet --cached HEAD -- && {
467 echo "No changes - did you forget to use 'git add'?"
468 stop_here_user_resolve $this
470 unmerged=$(git ls-files -u)
471 if test -n "$unmerged"
472 then
473 echo "You still have unmerged paths in your index"
474 echo "did you forget to use 'git add'?"
475 stop_here_user_resolve $this
477 apply_status=0
478 git rerere
480 esac
482 if test $apply_status = 1 && test "$threeway" = t
483 then
484 if (fall_back_3way)
485 then
486 # Applying the patch to an earlier tree and merging the
487 # result may have produced the same tree as ours.
488 git diff-index --quiet --cached HEAD -- && {
489 echo No changes -- Patch already applied.
490 go_next
491 continue
493 # clear apply_status -- we have successfully merged.
494 apply_status=0
497 if test $apply_status != 0
498 then
499 echo Patch failed at $msgnum.
500 stop_here_user_resolve $this
503 if test -x "$GIT_DIR"/hooks/pre-applypatch
504 then
505 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
508 tree=$(git write-tree) &&
509 parent=$(git rev-parse --verify HEAD) &&
510 commit=$(git commit-tree $tree -p $parent <"$dotest/final-commit") &&
511 git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
512 stop_here $this
514 if test -x "$GIT_DIR"/hooks/post-applypatch
515 then
516 "$GIT_DIR"/hooks/post-applypatch
519 go_next
520 done
522 git gc --auto
524 rm -fr "$dotest"